/////////////////////////////////////////////////////////////////////////////
// HookListView -- subclasses the listview pane in explorer
//
//    Copyright (c) 1999 Ziff Davis, Inc. All rights reserved
//    First appeared in PC Magazine, US Edition, August, 1999
//                Programmed by Mark Sweeney
//


#include "StdAfx.h"
#include "HookExplorer.h"
#include <commctrl.h>


extern HINSTANCE g_hInstance;

static LRESULT CALLBACK WindowProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
static CreateWind( HWND hParent );

/////////////////////////////////////////////////////////////////////////////
// 
CHookListView::CHookListView( )
{
	m_hWnd = 0;
	m_OldWndProc = 0;
}

/////////////////////////////////////////////////////////////////////////////
// 
CHookListView::~CHookListView( )
{
	UnSubClass( );
}



/////////////////////////////////////////////////////////////////////////////
// 
void CHookListView::SubClass( HWND hWnd )
{
	_ASSERT( hWnd );

	UnSubClass( );
	m_hWnd = hWnd;
	m_OldWndProc = reinterpret_cast<WNDPROC>( SetWindowLong( m_hWnd, GWL_WNDPROC,reinterpret_cast<LONG>( WndProc ) ) );
}	

/////////////////////////////////////////////////////////////////////////////
// 
void CHookListView::UnSubClass( )
{

	if( m_hWnd && m_OldWndProc )
		SetWindowLong( m_hWnd, GWL_WNDPROC, (LONG)m_OldWndProc);

	m_hWnd = 0;
}	

/////////////////////////////////////////////////////////////////////////////
// GetHwnd()
// returns the hwnd of the subclassed window
//
HWND CHookListView::GetHwnd()
{
	return( m_hWnd );
}

/////////////////////////////////////////////////////////////////////////////
// WndProc
// callback function for the listview control
//
LRESULT CALLBACK CHookListView::WndProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	CHookExplorer*  pThis = (CHookExplorer*)Get_pThis( );

	if( pThis == NULL )	
	{
		DEBUGOUT( _T("INVALID PTHIS CHookListView") );	
		return FALSE;
	}


	
	if( ( pThis->m_bLockFlags & DESKTOP_LOCKED ) )
	{
		//prevent drag and drop
		if( uMsg == LVM_CREATEDRAGIMAGE ) 
		{
			return 0;
		}


		if( (pThis->m_bLocked) && ( pThis->m_bLockFlags == EXPLORER_LOCKED ) )
		{
			
			switch( uMsg )
			{
				case WM_RBUTTONDOWN:
				case WM_COMMAND:
				case WM_RBUTTONDBLCLK:
				case WM_RBUTTONUP:
					return 1;

				case WM_CONTEXTMENU:
					return 0;

				case WM_MOUSEMOVE:
				case WM_NCMOUSEMOVE:
					SetCursor( pThis->m_hLockedCursor );
					if( wParam )
						return 1;
					break;

				case WM_SETCURSOR:
					SetCursor( pThis->m_hLockedCursor );
					return 1;

			}
		
		}
	}

	return( CallWindowProc( pThis->m_ListView.m_OldWndProc, hwnd, uMsg, wParam, lParam) );
}






