/////////////////////////////////////////////////////////////////////////////
// LockHlprObj.cpp : Implementation of CLockHlprObj
//
//
//    Copyright (c) 1999 Ziff Davis, Inc. All rights reserved
//    First appeared in PC Magazine, US Edition, August, 1999
//                Programmed by Mark Sweeney
//

#include "stdafx.h"
#include "Lockhlpr.h"
#include "LockHlprObj.h"
#include "ExDispID.h"


/////////////////////////////////////////////////////////////////////////////
// CLockHlprObj
CLockHlprObj::~CLockHlprObj()
{
	if( m_pHookExplorer )
		delete m_pHookExplorer;
	m_pHookExplorer = NULL;

}

/////////////////////////////////////////////////////////////////////////////
// 
CLockHlprObj::CLockHlprObj()
{
	m_pHookExplorer = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CLockHlprObj::ManageConnection(enum ConnectType eConnectType)
{
   if (!m_spWebBrowser2)
      return S_OK;

   HRESULT hr = 0;

   //
   // If eConnectType is Advise then we are advising IE that we
   // want to handle events.  If eConnectType is Unadvise, we are
   // telling IE that we no longer want to handle events.
   //
   CComQIPtr<IConnectionPointContainer,
             &IID_IConnectionPointContainer> spCPContainer(m_spWebBrowser2);

   if (spCPContainer != NULL)
   {
      CComPtr<IConnectionPoint> spConnectionPoint;

      hr = spCPContainer->FindConnectionPoint(DIID_DWebBrowserEvents2, &spConnectionPoint);
      if (SUCCEEDED(hr))
      {
         if (eConnectType == Advise)
         {
            //
            // Advise the client site of our desire to be handle events
            //
			hr = spConnectionPoint->Advise((IDispatch*)this, &m_dwCookie);
            if (FAILED(hr))
               DEBUGOUT( _T("ManageConnection(): Failed to Advise") );
         }
         else
         {
            // Remove us from the list of people interested...
            hr = spConnectionPoint->Unadvise(m_dwCookie);
         }
      }
   }

   return (SUCCEEDED(hr));
}

/////////////////////////////////////////////////////////////////////////////
// IOleObjectWithSite Methods
//
STDMETHODIMP CLockHlprObj::SetSite(IUnknown *pUnkSite)
{
   USES_CONVERSION;

   if (!pUnkSite)
      ATLTRACE("\nSetSite(): pUnkSite is NULL\n\n");
   else
   {
      // Query pUnkSite for the IWebBrowser2 interface.
      m_spWebBrowser2 = pUnkSite;

      if( m_spWebBrowser2 )
      {
		 m_pHookExplorer = new CHookExplorer;

         // Connect to the browser in order to handle events.
         if (!ManageConnection(Advise))
            ::MessageBox(NULL, _T("Failure sinking events from IWebBrowser2"), NULL, MB_OK);
      }
   }

   return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// 
STDMETHODIMP CLockHlprObj::Invoke(DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags,
                                DISPPARAMS* pDispParams, VARIANT* pvarResult,
                                EXCEPINFO*  pExcepInfo,  UINT* puArgErr)
{
	USES_CONVERSION;
	UNREFERENCED_PARAMETER( puArgErr );
	UNREFERENCED_PARAMETER( pExcepInfo );
	UNREFERENCED_PARAMETER( pvarResult );
	UNREFERENCED_PARAMETER( wFlags );
	UNREFERENCED_PARAMETER( lcid );
	UNREFERENCED_PARAMETER( riid );

	switch (dispidMember)
	{

      //explorer has changed folders, see if it is part of the Desktop
	  case DISPID_NAVIGATECOMPLETE2:
         if( pDispParams->rgvarg[0].vt == (VT_BYREF|VT_VARIANT) )
         {
            CComVariant varURL( *pDispParams->rgvarg[0].pvarVal );
            varURL.ChangeType( VT_BSTR );

			if( m_pHookExplorer )
				m_pHookExplorer->DirectoryChange( OLE2T(varURL.bstrVal) );
		
         }
         break;


	  //this instance of explorer is closing
	  case DISPID_ONQUIT:
     	ManageConnection( Unadvise );
		break;

	}
	   
	   return S_OK;
}
