#ifndef _FOLD_
#define _FOLD_


// Define a namespace extension
class ATL_NO_VTABLE CFolder: public IShellFolder, IPersistFolder
{
	protected:
		ULONG m_cRef;        
		TCHAR m_szFile[MAX_PATH];

	public:
		CFolder();
		~CFolder();
    
		// IUnknown methods
		STDMETHODIMP         QueryInterface( REFIID, LPVOID FAR* );
		STDMETHODIMP_(ULONG) AddRef();
		STDMETHODIMP_(ULONG) Release();

		// IShellFolder methods
		STDMETHODIMP ParseDisplayName( HWND, LPBC p, LPOLESTR, ULONG FAR*,
			LPITEMIDLIST *, ULONG * );
   	    STDMETHODIMP EnumObjects( HWND, DWORD, LPENUMIDLIST * );
  	    STDMETHODIMP BindToObject( LPCITEMIDLIST, LPBC, REFIID, 
			LPVOID FAR* );
	    STDMETHODIMP BindToStorage( LPCITEMIDLIST, LPBC, REFIID, 
			LPVOID FAR* );
	    STDMETHODIMP CompareIDs( LPARAM, LPCITEMIDLIST, LPCITEMIDLIST );
	    STDMETHODIMP CreateViewObject( HWND, REFIID, LPVOID FAR* );
	    STDMETHODIMP GetAttributesOf( UINT, LPCITEMIDLIST FAR*, ULONG FAR* );
	    STDMETHODIMP GetUIObjectOf( HWND, UINT, LPCITEMIDLIST FAR*, REFIID,
			UINT FAR*, LPVOID FAR* );
	    STDMETHODIMP GetDisplayNameOf( LPCITEMIDLIST, DWORD, LPSTRRET );
	    STDMETHODIMP SetNameOf(	HWND, LPCITEMIDLIST, LPCOLESTR, DWORD,
			LPITEMIDLIST FAR* );

		// IPersistFolder methods
    	STDMETHODIMP GetClassID( LPCLSID );
    	STDMETHODIMP Initialize( LPCITEMIDLIST );

		// custom methods
		STDMETHODIMP GetFileName( LPTSTR szFileName, INT iBufSize );
};

#endif
