// CallBack.h : Declaration of the CCallBack

#ifndef __CALLBACK_H_
#define __CALLBACK_H_

#include "resource.h"       // main symbols
#include <AtlCom.h>
#include <ShlObj.h>
#include "ICallBack.h"

/////////////////////////////////////////////////////////////////////////////
// CCallBack
class ATL_NO_VTABLE CCallBack : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCallBack, &CLSID_CallBack>,
	public ICallBackImpl,
	public IDispatchImpl<ICallBack, &IID_ICallBack, &LIBID_LOCKCOPYLib>
{
public:
	TCHAR m_szDesktopDir[MAX_PATH * sizeof(TCHAR)];
	TCHAR m_szDesktopDirectory[MAX_PATH * sizeof(TCHAR)];
	TCHAR m_szCommonDesktop[MAX_PATH * sizeof(TCHAR)];
	UINT  m_PrivateMessage;

	CCallBack()
	{
		m_PrivateMessage = 0;
		_tcscpy( m_szDesktopDir, "" );		
		_tcscpy( m_szDesktopDirectory, "" );		
		_tcscpy( m_szCommonDesktop, "" );		
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CALLBACK)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCallBack)
	COM_INTERFACE_ENTRY(ICallBack)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_IShellCopyHook, CCallBack)
END_COM_MAP()

// ICallBack
public:
	void GetDesktopFolders( );
	BOOL IsDesktopFolder( LPCSTR pDir );
	BOOL IsDesktopLocked( );

   STDMETHOD_(UINT, CopyCallback)(HWND hwnd, UINT wFunc, UINT wFlags,
                            LPCSTR pszSrcFile,  DWORD dwSrcAttribs,
                            LPCSTR pszDestFile, DWORD dwDestAttribs);



};

void _cdecl DebugOut_CompiledOutOfReleaseBuild( TCHAR *format,... );
#ifdef _DEBUG
#define DEBUGOUT DebugOut_CompiledOutOfReleaseBuild
#else
#define DEBUGOUT 1 ? (void)0 : DebugOut_CompiledOutOfReleaseBuild
#endif 


#endif //__CALLBACK_H_



