/////////////////////////////////////////////////////////////////////////////
// LockCopy.cpp : Implementation of DLL Exports.
//
//	  The is the copy hook handler which monitors file operations
//    to folders.   
//	  The CLSID for this extension is put into the registry under
//    HKCR\Directory\ShellEx\CopyHookHandlers
//
//    Copyright (c) 1999 Ziff Davis, Inc. All rights reserved
//    First appeared in PC Magazine, US Edition, August, 1999
//                Programmed by Mark Sweeney




// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f LockCopyps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "LockCopy.h"

#include "LockCopy_i.c"
#include "CallBack.h"


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_CallBack, CCallBack)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{

	if (dwReason == DLL_PROCESS_ATTACH)
    {
        DEBUGOUT( "DLL_PROCESS_ATTACH" );
		_Module.Init(ObjectMap, hInstance, &LIBID_LOCKCOPYLib);
        DisableThreadLibraryCalls(hInstance);
		
    }
    
	if (dwReason == DLL_PROCESS_DETACH)
	{
        DEBUGOUT( "DLL_PROCESS_DETACH" );
		_Module.Term();
	}

    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}




///////////////////////////////////////////////////////////////////////////////
//
void _cdecl DebugOut_CompiledOutOfReleaseBuild( TCHAR* format, ... )
{
	#ifdef _DEBUG

    static TCHAR szBuf[1024];
    static TCHAR sz[30];
	static va_list argptr;
	{
		va_start( argptr, format );
		wvsprintf( szBuf, format, argptr );
		va_end( argptr);
		wsprintf(sz, _T("%X  (LockCopy) "), GetCurrentThreadId() );
		OutputDebugString( sz );
		OutputDebugString( szBuf );
		OutputDebugString( _T("\n\r") );
	}

	#endif

}

