/////////////////////////////////////////////////////////////////////////////
// LockDlgs.cpp : Implementation of DLL Exports.
//
//	  This is the namespace extension to lock the common dialogs
//
//    Copyright (c) 1999 Ziff Davis, Inc. All rights reserved
//    First appeared in PC Magazine, US Edition, August, 1999
//                Programmed by Mark Sweeney



// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f LockDlgsps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "LockDlgs.h"

#include "LockDlgs_i.c"
#include "ExDisp.h"
#include "Shlobj.h"

#include "LockFolder.h"

BOOL bOKtoUnLoad;
HINSTANCE g_hInstance;
CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_LockFolder, CLockFolder)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    g_hInstance = hInstance;

    if (dwReason == DLL_PROCESS_ATTACH)
    {
        DEBUGOUT( "DLL_ATTACH" );
        _Module.Init(ObjectMap, hInstance, &LIBID_LOCKDLGSLib);
        DisableThreadLibraryCalls(hInstance);
    } else {
    
        if (dwReason == DLL_PROCESS_DETACH)
        {
            DEBUGOUT( "DLL_DETACH" );
            _Module.Term();
        }
    }
    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
   	DEBUGOUT( _T("DllCanUnloadNow bOKtoUnLoad=%x" ), bOKtoUnLoad );
	
	//Don't unload if we have subclassed a common dialog!
	if( !bOKtoUnLoad )
		return S_FALSE;

	return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}


