#ifndef _LOCKFOLDER_
#define _LOCKFOLDER_


// Define a namespace extension
class ATL_NO_VTABLE CFolder: public IShellFolder, IPersistFolder
{
	protected:
		ULONG m_cRef;        

	public:
		CFolder();
		~CFolder();

	// *** IUnknown methods ***
	STDMETHODIMP QueryInterface(
		REFIID riid, 
		LPVOID FAR* ppvObj);
	STDMETHODIMP_(ULONG) AddRef(void);
	STDMETHODIMP_(ULONG) Release(void);

	// *** IParseDisplayName method ***
	STDMETHODIMP ParseDisplayName(
		HWND hwndOwner,
		LPBC pbc, 
		LPOLESTR lpszDisplayName,
		ULONG FAR* pchEaten, 
		LPITEMIDLIST * ppidl,
		ULONG *pdwAttributes);

	// *** IOleContainer methods ***
	STDMETHODIMP EnumObjects(
		HWND hwndOwner, 
		DWORD grfFlags,
		LPENUMIDLIST * ppenumIDList);

	// *** IShellFolder methods ***
	STDMETHODIMP BindToObject(
		LPCITEMIDLIST pidl, 
		LPBC pbc,
		REFIID riid, 
		LPVOID FAR* ppvObj);
	STDMETHODIMP BindToStorage(
		LPCITEMIDLIST pidl, 
		LPBC pbc,
		REFIID riid, 
		LPVOID FAR* ppvObj);
	STDMETHODIMP CompareIDs(
		LPARAM lParam, 
		LPCITEMIDLIST pidl1,
		LPCITEMIDLIST pidl2);
	STDMETHODIMP CreateViewObject(
		HWND hwndOwner, 
		REFIID riid,
		LPVOID FAR* ppvObj);
	STDMETHODIMP GetAttributesOf(
		UINT cidl, 
		LPCITEMIDLIST FAR* apidl,
		ULONG FAR* rgfInOut);
	STDMETHODIMP GetUIObjectOf(
		HWND hwndOwner, 
		UINT cidl, 
		LPCITEMIDLIST FAR* apidl, 
		REFIID riid, 
		UINT FAR* prgfInOut, 
		LPVOID FAR* ppvObj);
	STDMETHODIMP GetDisplayNameOf(
		LPCITEMIDLIST pidl, 
		DWORD dwReserved, 
		LPSTRRET lpName);
	STDMETHODIMP SetNameOf(
		HWND hwndOwner, 
		LPCITEMIDLIST pidl,
		LPCOLESTR lpszName, 
		DWORD dwReserved,
		LPITEMIDLIST FAR* ppidlOut);

	// *** IPersist methods ***
	STDMETHODIMP GetClassID(
		LPCLSID lpClassID);
	// *** IPersistFolder methods ***
	STDMETHODIMP Initialize(
		LPCITEMIDLIST pidl);
};

#endif
